<?php

namespace WordBundle\Repository;


use Psr\Log\LoggerInterface;
use Schema\SchemaEntityRepository;
use UserBundle\Entity\User;
use Utils\StaticUtil\LogUtils;
use WordBundle\Entity\Word;
use Doctrine\Common\Persistence\ManagerRegistry;


/**
 * WordRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class WordRepository extends SchemaEntityRepository {

    const DEFAULT_MAX_RESULTS = 50;

    /** @var LoggerInterface $logger */
    private $logger;

    /**
     * WordRepository constructor.
     * @param ManagerRegistry $registry
     * @param LoggerInterface $logger
     */
    public function __construct(ManagerRegistry $registry, LoggerInterface $logger) {
        parent::__construct($registry, Word::class);

        $this->logger = $logger;
    }

    /**
     * @param int $page
     * @param null|string $suggest
     * @param int $maxResults
     * @param string $sort
     * @return array|\Doctrine\ORM\Tools\Pagination\Paginator
     */
    public function findAllPaginatedWords ($page=1, ?string $suggest, $maxResults=self::DEFAULT_MAX_RESULTS, $sort='DESC') {

        if (!is_null($suggest)) {

            $dql = 'SELECT w.id, w.value, w.name, w.optionals, w.statusCheck, w.statusPayment, w.isVerified, u.id as user_id, u.username,
                   (SELECT 1 + COUNT(0)
                    FROM WordBundle:Word w2
                    WHERE w2.value > w.value OR 
                        ( w2.value = w.value AND w2.id < w.id )
                   ) as rank
                FROM WordBundle:Word w
                INNER JOIN w.user u
                WHERE w.name LIKE :wordName
                ORDER BY w.value DESC';

            $query = $this->getEntityManager()->createQuery($dql)
                ->setParameter('wordName', '%'.$suggest.'%')
            ;

        } else {
            $dql = 'SELECT w.id, w.value, w.name, w.optionals, w.statusCheck, w.statusPayment, w.isVerified, u.id as user_id, u.username,
                   (SELECT 1 + COUNT(0)
                    FROM WordBundle:Word w2
                    WHERE w2.value > w.value OR 
                        ( w2.value = w.value AND w2.id < w.id )
                   ) as rank
                FROM WordBundle:Word w
                INNER JOIN w.user u
                ORDER BY w.value DESC';

            $query = $this->getEntityManager()->createQuery($dql);
        }

//        $qb = $this->getEntityManager()->createQueryBuilder();
//        $qb->select('w')
//            ->from('WordBundle:Word', 'w');
//
//        if (!is_null($suggest)) {
//            $qb->where('w.name LIKE :name')
//            ->setParameter('name', '%'.$suggest.'%');
//        }
//
//        $qb->orderBy('w.id',$sort);

        $results = array();

        try {
//            $query   = $qb->getQuery();
            $results = $this->paginate($query,$page,$maxResults,false);
        } catch (\Exception $e) {
            $exception = LogUtils::getFormattedExceptions($e);
            $this->logger->error("Failed get all words", $exception);
        }

        return $results;

    }

    /**
     * @param User $user
     * @param int $page
     * @param null|string $suggest
     * @param int $maxResults
     * @param string $sort
     * @return array|\Doctrine\ORM\Tools\Pagination\Paginator
     */
    public function findAllPaginatedWordsByUser (User &$user, $page=1, ?string $suggest, $maxResults=self::DEFAULT_MAX_RESULTS, $sort='DESC') {

        if (!is_null($suggest)) {

            $dql = 'SELECT w.id, w.value, w.name, w.optionals, w.statusCheck, w.statusPayment, w.isVerified,
                   (SELECT 1 + COUNT(0)
                    FROM WordBundle:Word w2
                    WHERE w2.value > w.value OR 
                        ( w2.value = w.value AND w2.id < w.id )
                   ) as rank
                FROM WordBundle:Word w
                WHERE w.user = :userToCheck AND w.name LIKE :wordName
                ORDER BY w.value DESC';

            $query = $this->getEntityManager()->createQuery($dql)
                ->setParameter('userToCheck', $user)
                ->setParameter('wordName', '%'.$suggest.'%')
            ;

        } else {
            $dql = 'SELECT w.id, w.value, w.name, w.optionals, w.statusCheck, w.statusPayment, w.isVerified,
                   (SELECT 1 + COUNT(0)
                    FROM WordBundle:Word w2
                    WHERE w2.value > w.value OR 
                        ( w2.value = w.value AND w2.id < w.id )
                   ) as rank
                FROM WordBundle:Word w
                WHERE w.user = :userToCheck
                ORDER BY w.value DESC';

            $query = $this->getEntityManager()->createQuery($dql)
                ->setParameter('userToCheck', $user);
        }


//        $qb = $this->getEntityManager()->createQueryBuilder();
//        $qb->select('w')
//            ->from('WordBundle:Word', 'w')
//            ->where('w.user = :user')
//            ->setParameter('user', $user)
//        ;
//
//        if (!is_null($suggest)) {
//            $qb->andWhere('w.name LIKE :name')
//                ->setParameter('name', '%'.$suggest.'%');
//        }
//
//        $qb->orderBy('w.value',$sort);

        $results = array();

        try {
//            $query   = $qb->getQuery();
            $results = $this->paginate($query,$page,$maxResults,false);
        } catch (\Exception $e) {
            $exception = LogUtils::getFormattedExceptions($e);
            $this->logger->error("Failed get all words by user ID: ".$user->getId(), $exception);
        }

        return $results;

    }


    /**
     * @param User $user
     * @param $hash
     * @return mixed|null
     */
    public function findWordByHash (User &$user, $hash) {

        $dql = 'SELECT w.id, w.value, w.name, w.optionals, w.statusCheck, w.statusPayment, w.isVerified,
                   (SELECT 1 + COUNT(0)
                    FROM WordBundle:Word w2
                    WHERE w2.value > w.value OR 
                        ( w2.value = w.value AND w2.id < w.id )
                   ) as rank
                FROM WordBundle:Word w
                WHERE w.user = :userToCheck AND w.hash = :hash';

        $query = $this->getEntityManager()->createQuery($dql)
            ->setParameter('userToCheck', $user)
            ->setParameter('hash', $hash)
        ;

        $result = null;

        try {
            $result = $query->setMaxResults(1)->getOneOrNullResult();
        } catch (\Exception $e) {
            $exception = LogUtils::getFormattedExceptions($e);
            $this->logger->error("Failed get word by user ID: ".$user->getId()." and hash: ".$hash, $exception);
        }

        return $result;
    }

    /**
     * findWordByName function
     *
     * @param string $name
     * @return mixed|null
     */
    public function findWordByName ($name) {

        $dql = 'SELECT w.id, IDENTITY(w.user) as user_id, w.value, w.name, w.hash, w.editedAt, w.optionals, w.statusCheck, w.statusPayment, w.isVerified,
                   (SELECT 1 + COUNT(0)
                    FROM WordBundle:Word w2
                    WHERE w2.value > w.value OR 
                        ( w2.value = w.value AND w2.id < w.id )
                   ) as rank
                FROM WordBundle:Word w
                WHERE w.name = :nameToCheck';

        $query = $this->getEntityManager()->createQuery($dql)
            ->setParameter('nameToCheck', $name)
        ;

        $result = null;

        try {
            $result = $query->setMaxResults(1)->getOneOrNullResult();
        } catch (\Exception $e) {
            $exception = LogUtils::getFormattedExceptions($e);
            var_dump($exception);die("ex");
            $this->logger->error("Failed get word by name: ".$name, $exception);
        }

        return $result;
    }

    /**
     * @param int $value
     * @return mixed|null
     */
    public function findRankByValue ($value=1) {

        $dql = 'SELECT w.id,
                   (SELECT 1 + COUNT(0)
                    FROM WordBundle:Word w2
                    WHERE w2.value > w.value OR 
                        ( w2.value = w.value AND w2.id < w.id )
                   ) as rank
                FROM WordBundle:Word w
                WHERE w.value >= :valueToCompare
                ORDER BY rank DESC';

        $query = $this->getEntityManager()->createQuery($dql)
            ->setParameter('valueToCompare', $value);

        $result = null;

        try {
            $result = $query->setMaxResults(1)->getOneOrNullResult();
        } catch (\Exception $e) {
            $exception = LogUtils::getFormattedExceptions($e);
            $this->logger->error("Failed get rank by value: ".$value, $exception);
        }

        return $result;
    }


    /**
     * @return mixed|null
     */
    public function findKingWordValue () {

        $dql = 'SELECT w.value
                FROM WordBundle:Word w
                ORDER BY w.value DESC';

        $query = $this->getEntityManager()->createQuery($dql);

        $result = null;

        try {
            $result = $query->setMaxResults(1)->getOneOrNullResult();
        } catch (\Exception $e) {
            $exception = LogUtils::getFormattedExceptions($e);
            $this->logger->error("Failed get king's word value", $exception);
        }

        return $result;
    }

    /**
     * @return Word|null
     */
    public function findKingWord () {

        $qb = $this->getEntityManager()->createQueryBuilder();
        $qb->select('w')
            ->from('WordBundle:Word', 'w')
            ->orderBy('w.value', 'DESC')
        ;

        $result = null;

        try {
            $result = $qb->setMaxResults(1)->getQuery()->getOneOrNullResult();
        } catch (\Exception $e) {
            $exception = LogUtils::getFormattedExceptions($e);
            $this->logger->error("Failed get king's word value", $exception);
        }

        return $result;
    }



    /**
     * findKingUserId function
     *
     * @return mixed|null
     */
    public function findKingUserId () {

        $dql = 'SELECT IDENTITY(w.user) as user_id
                FROM WordBundle:Word w
                ORDER BY w.value DESC';

        $query = $this->getEntityManager()->createQuery($dql)
        ;

        $result = null;

        try {
            $result = $query->setMaxResults(1)->getOneOrNullResult();
        } catch (\Exception $e) {
            $exception = LogUtils::getFormattedExceptions($e);
            var_dump($exception);die("ex");
            $this->logger->error("Failed get king user id", $exception);
        }

        return $result;
    }

    /**
     * @param Word $word
     * @return mixed|null
     */
    public function findByName (Word &$word) {

        $qb = $this->getEntityManager()->createQueryBuilder();
        $qb->select('w.id')
            ->from('WordBundle:Word', 'w')
            ->where('w.name = :name')
            ->setParameter('name', $word->getName())
        ;

        $result = null;

        try {
            $result = $qb->setMaxResults(1)->getQuery()->getOneOrNullResult();
        } catch (\Exception $e) {
            $exception = LogUtils::getFormattedExceptions($e);
            $this->logger->error("Failed get word by name", $exception);
        }

        return $result;
    }


    /**
     * @param Word $word
     * @return mixed|null
     */
    public function findByHash (Word &$word) {

        $qb = $this->getEntityManager()->createQueryBuilder();
        $qb->select('w.id')
            ->from('WordBundle:Word', 'w')
            ->where('w.hash = :hash')
            ->setParameter('hash', $word->getHash())
        ;

        $result = null;

        try {
            $result = $qb->setMaxResults(1)->getQuery()->getOneOrNullResult();
        } catch (\Exception $e) {
            $exception = LogUtils::getFormattedExceptions($e);
            $this->logger->error("Failed get word by hash", $exception);
        }

        return $result;
    }

}
